# wpgpRFPMS : Random Forests population modelling scripts 

[![N|Solid](http://maps.worldpop.org.uk/img/worldpop-logo.png)](http://maps.worldpop.org.uk)

# Introduction
wpgpRFPMS is a population modelling R script utilizing Random Forests to inform a dasymetric redistribution of census-based population count data. Read more about the method in [https://doi.org/10.1371/journal.pone.0107042](https://doi.org/10.1371/journal.pone.0107042) 
All census data, zonal stats and covariates for 249 countries are stored on [WorldPop](http://www.worldpop.org.uk) FTP and downloaded into a project by using the R package [wpgpCovariates](https://github.com/wpgp/wpgpCovariates)


* [Introduction ](README.md)
* [Dependencies and installation ](docs/Dependencies.md)
* [Getting started ](docs/GettingStarted.md)
* [Outputs ](docs/Outputs.md)
* [Using Shape file ](docs/Shapefile.md)
* [Using AdminID ](docs/AdminID.md)


## Contributing
WorldPop (www.worldpop.org - School of Geography and Environmental Science, University of Southampton; Department of Geography and Geosciences, University of Louisville; Departement de Geographie, Universite de Namur) and Center for International Earth Science Information Network (CIESIN), Columbia University (2018) in the framework of Global High Resolution Population Denominators Project - Funded by The Bill and Melinda Gates Foundation (OPP1134076). More about the method in https://doi.org/10.1371/journal.pone.0107042. The WorldPop Random Forests population modelling R scripts (wpgpRFPMS) was developed by Maksym Bondarenko and Jeremiah Nieves. Input data have been contributed by many different researchers within the WorldPop Research Group. Information and sources of the input population data are <a href="https://www.worldpop.org/resources/docs/national_boundaries/global-input-population-data-summary.xlsx" target="_blank" title="input population data" >available here</a>. Read more about the method in <a href="https://doi.org/10.1371/journal.pone.0107042">
https://doi.org/10.1371/journal.pone.0107042</a>.

**Suggested citation:**  
Maksym Bondarenko, Jeremiah J. Nieves,  Alessandro Sorichetta, Forrest R Stevens, Andrea E. Gaughan, and Andrew J. Tatem  2020. wpgpRFPMS: Random Forests population modelling R scripts, version 0.1.0. University of Southampton: Southampton, UK. doi:<a href="https://dx.doi.org/10.5258/SOTON/WP00665" target="_blank">10.5258/SOTON/WP00665</a>. 

## License
<a href='COPYING' target='_blank'>GNU General Public License v3.0 (GNU GPLv3)]</a>  

